/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *
 * Copyright (C) 2011-2019 Emad Shafie
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

define codes = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~".

define anascii(X) = {
 if X>=32 and X<=126 then { codes[X-32] } else { "===" }
}.

/********************************************************************************/
define 	LowerCase(X,ReceiveString)= {     			 /* X will be used for return variable*/
		exists A2,A1:{stable (ReceiveString) and List(A2,|ReceiveString|) and A2=[] and 
				{ for i < |ReceiveString| 
				do{            
				A2:=A2+[ascii(ReceiveString[i])] and skip } 
				};{
				A1="" and stable(A2) and stable(ReceiveString) and 
				{ 	for i < |ReceiveString| 
					do	{ 
						if (A2[i]>=65 and  A2[i]<=90) 
							then {A1 := A1 + anascii(A2[i]+32) and skip }
							else {A1:=A1+ReceiveString[i] and skip }
						} 
				}  and  fin(X=A1)
				} 
			}
		}.

/********************************************************************************/
define DecreaseSpaces(X,S) = {
  exists A1,A2,E : { List(A2,|S|) and stable(S) and A2=[] and {
					for i < |S| do{
						if S[i]~=" " then  {A2:=A2+[i] and skip  } else {skip and  A2:=A2}}};
					{stable(S) and stable(A2) and A1 ="" and E=A2[0] and 
					for i < |A2|-1	do{
                 		if (A2[i+1]-A2[i]=1) 
							then{ stable(A1) and E:=E and  skip }
							else{ A1 :=  A1+S[E..A2[i]+1]+" " and  E:= A2[i+1]  and  skip}
						} and fin(X=A1+S[E..A2[|A2|-1]+1]) 
						 }
					}
				}.
/********************************************************************************/
define StringTokens(X,S) = {
  exists A1,A2,E : { List(A2,|S|) and stable(S) and A2=[] and {
					for i < |S| do{
						if S[i]~=" " then  {A2:=A2+[i] and skip  } else {skip and  A2:=A2}}};
					{stable(S) and stable(A2) and List(A1,|S|) and A1 =[] and E=A2[0] and 
					for i < |A2|-1	do{
                 		if (A2[i+1]-A2[i]=1) 
						then { A1:=A1 and E:=E and  skip }
						else{ A1:= A1+[S[E..A2[i]+1]] and  E:= A2[i+1]  and  skip}
						} and fin(X=A1+[S[E..A2[|A2|-1]+1]]) 
						 }
					}
				}.					
/********************************************************************************/
define SearchGenKeywords(X,S) = {
	exists A,I,J,SQLKeys:{{
	StringTokens(X,S) and fin(T=X)};{ 
	stable(T) and 
	SQLKeys=["select","drop","update","delete","alter","create","union","declare","bigen","exec","ascii"] 
	and stable(SQLKeys) and I=0 and J=0 and A='g' and {
			while  I < |SQLKeys|
				do{ while J < |T|
					do{ 
						if (SQLKeys[I]=T[J])
							then {I:=|SQLKeys| and J:=|T| and  skip and A:='n'} 
							else {I:=I and skip and J:=J+1 and A:=A}
						};{ I:=I+1 and  J:=0 and skip and A:=A }
					} and fin(X=A) 
			 }
		  }
		}
	 }.
/********************************************************************************/	 
define SearchSpecKword(X,S,D) = {
	exists A,I,Q,G:{stable (D) and stable (S) and {
	{StringTokens(Q,S)};
	{stable(Q) and  I=0 and J=0 and A='n' and G=0 and  {
			while  I < |D|
				do{ if (D[I]=Q[0])
					then {I:=|D| and  skip and A:='y' and G:=|Q[0]|} 
					else { I:=I+1 and skip and A:=A and G:=G}
					}  
			 }and fin(X=[A,G])
		  }
		}
	 }}.
	 
	 
	 
/********************************************************************************/	
define StringCommentCut(X,S) = {
  exists A1,A2,T,B : { List(A1,|S|) and stable(S) and A1=[] and T=0 and  B=0 and {
					for i < |S|  
						do{
						if (S[i..i+2]= "/*" and T=0)
							then {T:=1 and B:=i and A1:=A1} 
							else { if (S[i..i+2]= "*/" and T=1 )
									then { A1:=A1+[B]+["s"]+[i+1] and T:=0 and B:=B}
									else {A1:=A1 and T:=T and B:=B}} and skip }};
				{ stable(S) and stable(A1) and A2="" and 
					 if |A1|>0 
						then {
								for i<|A1|
								do{	if A1[i]="s" 
									then {  if (|A2|=0)
											then {A2:=S[0..A1[i-1]]+S[A1[i+1]+1..i+1]+S[A1[i+1]+1..A1[i+2]]} 
											else { if ((i+2)=|A1|) then{ A2:=A2+S[A1[i+1]+1..i+1]+S[A1[i+1]+1..|S|]} 
																   else{ A2:=A2+S[A1[i+1]+1..i+1]+S[A1[i+1]+1..A1[i+2]]}  }}
									else {A2:=A2} and skip}}
						else {A2:= S and skip}
						}and  output (S) and fin(X=A2)
					 }
				}.	 
/********************************************************************************/	 

/********************************************************************************/
define GoodEntry(X,S)={
exists A,I:{ 
   stable(S) and A='g' and I=0 and  while I < |S| do {
	  if (S[0..2]='0x' or  S[I..I+3]=" 0x")
		then {I:=|S| and A:='n' and skip}
		else {if  (ascii(S[I])>= 97  and ascii(S[I])<= 122) 
				then { stable(A) and I:=I+1 and skip}
				else {if  (ascii(S[I])>= 48 and ascii(S[I])<=58)
						then {stable(A) and I:=I+1 and skip}
						else {if (ascii(S[I])= 32 or ascii(S[I])= 33 or ascii(S[I]) = 63 or 
						ascii(S[I]) = 95 or ascii(S[I]) = 43 or ascii(S[I]) = 61)
								then {stable(A) and I:=I+1 and skip}
								else {next(A)='n' and I:=|S| and skip }}}}} /*return n means not good entry*/
				and fin (X=A) 
				}}.				

define BadEntry(X,S)={
exists A,D,I,F,G: {
				{stable(S) and stable(struct(S)) and  A='u' and I =0 and
				  while I < |S| 
						do{ if ((S[I..I+2]= "--" and (I+2 <= |S|)) or (S[I..I+3]= "- -" and (I+3 <= |S|)))
								then{I:=|S| and A:='b'}
								else{A:=A and I:=I+1} and skip}};
				{stable(S) and skip and if (A ='b') then{A:=A and  I:=I} else{A:=A and I:=0}};
				{stable(S) and 
					while I < |S|
					do{ 
						if (S[I..I+2]= "/*" and (I+2 < |S|)) or (S[I..I+3]= "/ *" and (I+3 < |S|))
							then{ D=I+2 and 
								while (D < |S|)
									do {if (S[D..D+2]= "*/" or S[D..D+3]= "* /")
										then {I:=|S| and A:='b' and skip and D:=|S|}
										else {I:=|S|and A:='u' and skip and D:=D+1}}}									 
							else{ if (S[I..I+2]= "/*" and (I+2 >= |S|)) or (S[I..I+3]= "/ *" and (I+3 >= |S|)) 
								then{I:=|S| and A:='b' and skip and D:=|S|} else{
							A:=A and skip and I:=I+1}}}};
							
				{stable(S) and skip and if (A ='b') then{A:=A and  I:=I} else{A:=A and I:=0}};
				{stable(S) and {		
		 while I < |S|
		do{ 	
		if (S[I]= ";" and I+1<|S|)
			then{				
				{stable (A) and stable(I) and 
				
			{{SearchSpecKword(N,S[I+1..|S|],["drop","alter","create","declare"])};{stable N}} and
			  SearchSpecKword(X,S[I+1..|S|],["select","update","bigen","exec","delete","insert"])};
			{if N[0]= 'y' 
			  then {A:='b' and I:=|S| and stable X}
			  else {stable X and stable (A) and stable(I)} and skip};
				{D=I+X[1]+1  and  
				if X[0]='y'
					then{
					while (D < |S|) 
					do {if (S[D]= ";" or S[D]= "#" or  S[D]= "--" or  S[D]="'" or S[D..D+1]=" @" or S[D]="*" or S[D..D+5]="table" )
											then {A:='b' and skip and D:=|S| and I:=|S|}
											else {A:='OB' and skip and D:=D+1 and I:=|S|}}}
								else{A:=A and skip and I:=I+1}}}
							else{if (S[I]= ";") and (I+1 >= |S|)
								then{I:=|S| and A:='b' and skip} 
								else{A:=A and skip and I:=I+1}}}}};
								
				{stable(S) and skip and if (A ='b') then{A:=A and  I:=I} else{A:=A and I:=0}};
				{stable(S) and {	
				 while I < |S|
					do{ 
					if (S[I]= "'" and I+1<|S|)
							then{
							{stable (A) and stable(I) and SearchSpecKword(X,S[I+1..|S|],["union","or","and","group","order"]) };
							{ D=I+X[1]+1  and  if X[0]='y'
								then{
								while (D < |S|) 
											do {if (S[D]= ";" or  S[D]="=" or S[D]= "-" or S[D]="%" or S[D]="'" or S[D..D+6]="select" )
											then {A:='b' and skip and D:=|S| and I:=|S|}
											else {A:='OB' and skip and D:=D+1 and I:=|S|}}}
								else{A:=A and skip and I:=I+1}}}
							else{if (S[I]= "'") and (I+1 >= |S|)
								then{I:=|S| and A:='b' and skip} 
								else{A:=A and skip and I:=I+1}}}}};

			{stable(S) and skip and if (A ='b') then{A:=A and  I:=I} else{A:=A and I:=0}};
			{stable(S) and
					while I < |S|
					do{ if ((S[I..I+3]= " 0x") and 
						   (((ascii(S[I+3])>= 48 and ascii(S[I+3])<=57) or (ascii(S[I+3])>= 97 and ascii(S[I+3])<=102)) and 
					        ((ascii(S[I+4])>= 48 and ascii(S[I+4])<=57) or (ascii(S[I+4])>= 97 and ascii(S[I+4])<=102))))	
						then{I:=|S| and skip and  A:='b'}
						else{A:=A and skip and  I:=I+1}}};
				{stable(S) and skip and if (A ='b') then{A:=A and  I:=I} else{A:=A and I:=0}};
				{stable(S) and
				while I < |S|  
					do{if (S[I..I+6]= " char("  or S[I..I+7]= " char (" or S[I..I+5]= "char(" or S[I..I+6]= " exec(" 
					or S[I..I+5]= "exec(" or S[I..I+6]= "select(" or S[I..I+6]= " select(" or S[I..I+3]= "%00" 
					or S[I..I+3]= "%2f" or S[I..I+3]= "%2a" or S[I..I+5]= "%252f" or S[I..I+5]= "%252a" )	
						then{I:=|S| and skip and A:='b'}
						else{A:=A and skip and I:=I+1}}};
			{stable(S) and skip and if (A ='b') then{A:=A and  I:=I} else{A:=A and I:=0}};						
			{stable(S) and if A='u' then A:='g' else A:=A and skip}
					and fin (X=A)
				}
			}.		
/**************************************************************************************/

define extend_list(L,d) = {														/*to fill an extendible array*/
    list(next L, |L|+1) and 
          forall i<|L|+1: if i<|L| then L[i]:=L[i] else L[i]:=d
}.
/********************************************************************************/
define SearchProcedure(X,S,N) = {
	exists A,I,J,DProcedure:{{
	StringTokens(T,S)};
	{stable(T) and DProcedure=["declare","select","exec"] 
	and stable(DProcedure) and I=0 and J=0 and List(A,|T|) and A=[] and {
			while  I < |DProcedure|
				do{ while J < |T|
					do{if (DProcedure[I]=T[J])
							then {I:=|DProcedure| and J:=|T| and  skip and A:=A+[N]+[DProcedure[I]]+[T[J+1]]} 
							else {I:=I and skip and J:=J+1 and A:=A}
						};{ I:=I+1 and  J:=0 and skip and A:=A }
					} and fin(X=A)  
			 }
		  }
		}
	 }.
/********************************************************************************/

 define Filter(X,N) = {
     exists A,T:{
  {List(A,|N|) and A=[] and List(T,|N|) and 
             while (|N| ~=0 ) do{
                 {A:=A+[N[0]] and N:=N[1..|N|] and skip};
                 {stable A and stable N and
                   T=[] and 
                  for i<|N| do {
                     if  N[i] ~=A[|A|-1]
                     then {T:=T+[N[i]]}
                     else {T:=T} and skip
                  }
                 ;{N:=T and stable A and skip}
                 }
                } and fin(X=A)
          }
      }
}.
define ReltedIP(H) = {					
	exists I,X,T,HH,G,D: {
	{stable(H) and { List(HH,|H|) and HH=[] and List(D,|HH|) and D=[] and
	for i<|H| do {if H[i][1] ='b'
					then{HH:=HH+[i] and D:=D+[H[i][0]]}  
					else{HH:=HH and D:=D} 
					and skip}};{ stable HH and stable H and Filter(X,D)};
	{List(G,|H|) and List(T,|HH|) and T=[] and G=[] and I=0 and  stable HH and stable H and stable X 
	and while I < |X|  do{  
			for j<|HH| do { stable (G) and stable I and 
			if X[I]=H[HH[j]][0]
			then {T:=T+[H[HH[j]][3]] }
			else {T:=T} and skip};{T:=[] and I:=I+1 and  G:=G+[[X[I]]+[T]]
			and skip}
                } and fin output (G)
	}}}}.

  /********************************************************************************/
define BuildBehaviour(H) = {					
		exists I,X,T,HH,G,D: {
		{stable(H) and 
		{ ReltedIP(H)   and format("\n***********************Related IP with bad input *********************\n\n")} ;
		{  format("********************** Sequence of bad input **********************\n\n") and if |H|>2 
		then {List(G,|H|) and G=[] and 
			for i<|H|-2 
				do {if (H[i][1] ='b' and H[i+1][1] ='b' and H[i+2][1] ='b' and i~=0)
					then { if (H[i-1][1] ='b' and H[i][1] ='b' and H[i+1][1] ='b') and i>0 
							  then{G:=G+[[H[i][0]]+[H[i+2][3]]]}
							  else{G:=G+["New Sequence"]+[[H[i][0]]+[H[i][3]]]+[[H[i][0]]+[H[i+1][3]]]+[[H[i][0]]+[H[i+2][3]]]}}
					else{G:=G} and skip} and fin(output(G))}
		else{empty}};
		{format("********************** Percentage of all  input  **********************\n\n") and
		T=0 and I=0 and  
		for i<|H| do { 
			if H[i][1] ='b' 
			then {T:=T+1 and I:=I }
			else {T:=T and if H[i][1] ='u' then I:=I+1 else I:=I}
		and skip}};
		{stable(T) and stable(I)  and 
		G=itof(T)*$100$/itof(|H|)  and 
		D=itof(I)*$100$/itof(|H|) and 
		format("the percentage of bad  inputs  is: %F \n",G) and 
		format("the percentage of unspecified  inputs  is: %F \n",D) and 
		format("the percentage of good inputs  is: %F \n",($100$-(G+D))) and empty};
		{format("*********************** Related Database Procedure *********************\n\n") and List(HH,|H|) and HH=[] and  
			for i<|H| do { if H[i][1] ='b' 
							then {{SearchProcedure(X,H[i][2],i) and stable(HH)};
								 {if X~=[] then HH:=HH+[X] else HH:=HH and skip}}
							else {skip and HH:=HH}
							}and fin(output(HH))};
		{stable(HH) and List(P,|HH|) and P=[] and 
			for i<|HH|-1
				do { 
					if HH[0][2]=HH[i][
					2]  
						then{P:=P+[HH[i][0]]}  else{P:=P} and skip}} 
						and fin(output(P))
			}
		
		}}.
	
/************************************end  of  behaviour ********************************************/
define CheckingModel(X,S) = {
  exists D,R,F,T,M:{
	 {stable(S) and LowerCase(T,S)};
     {stable(T) and  DecreaseSpaces(R,T)};
	 {stable(R) and SearchGenKeywords(D,R)};
	 {stable(R) and stable(D) and GoodEntry(F,R)};
	 {stable(R) and  stable(D) and stable(F) and	 
	 {if (D='g' and F='g') 
	 then{M='g' and empty}
	 else{BadEntry(M,R)}}}  and fin(X=M)}
	}.
/**************************************************************************************/	
  /* run */ define TestCheckingModelFromFile2() = {
	exists X,S,H:{
	 {set outfile="stdout" and set infile="ssss" and 
          list(H,0) and input X and
                while (X ~= 0)
                    do {extend_list(H,X) and skip and next input X}};{
				stable(H) and 
				for i<|H|
				do {{CheckingModel(S,H[i][1])};
				    {
					if S = H[i][3] then{ format("\n Number %d done %t :  %t \n",i+1,S,H[i][1])}
								   else {output ('sorry') and format("Number %d is %t  Expecting %t for: %t \n",i+1,S,H[i][3],H[i][1]) }
								   and  format("\n ============================= \n")and skip}
					}
					}
				   }
	  }.
  
  /* run */ define TestCheckingModelFromFile1() = {
 exists X,S,H,BehaviourArray:{
    list(BehaviourArray,0) and  
    {set outfile="stdout" and set infile="ssss" and 
     list(H,0) and input X and
     while (X ~= 0) do {
      extend_list(H,X) and skip 
      and next input X
     } 
    };
    {stable(H) and BehaviourArray=[] and
     for i<|H| do {
      {CheckingModel(S,H[i][1]) and stable(BehaviourArray)    
      };
      {stable(S) and 
	  format("Number %d is: %t , and Expecting : %t for: %t \n",i,S,H[i][3],H[i][1])
	  and extend_list(BehaviourArray,[H[i][0]]+[S]+[H[i][1]]+[H[i][2]]) 
       and skip
      }
     }
    };{stable(H) and stable(BehaviourArray) and BuildBehaviour(BehaviourArray)}
  
   }	
}.
  /* run */ define TestCheckingModelFromFile3() = {
 exists X,S,H,BehaviourArray:{
    list(BehaviourArray,0) and  
    {set outfile="stdout" and set infile="ssss" and 
     list(H,0) and input X and
     while (X ~= 0) do {
      extend_list(H,X) and skip 
      and next input X
     } 
    };
    {stable(H) and BehaviourArray=[] and
     for i<|H| do {
      {CheckingModel(S,H[i][1]) and stable(BehaviourArray)    
      };
      {stable(S) and output (S) and 
	   extend_list(BehaviourArray,[H[i][0]]+[S]+[H[i][1]]+[H[i][2]]) 
       and skip
      }
     }
    };{stable(H) and stable(BehaviourArray) and BuildBehaviour(BehaviourArray)}
  
   }	
}.
 
 
  
  


