# lifts5.tcl --
#
#
# Copyright (C) 2012-2019 Amin Mohammed El-kustaban

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#package require NAME VERSION
package provide transaction1 1.0
# Namespace out --
#
#   ADD COMMENTS HERE
#
namespace eval ::out {;
#namespace export -clear *
variable nprocesses;
variable ntransactions;
variable nlocations;
variable canv;
variable col;

# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#


proc init {nl} {
  variable canv;
  variable nprocesses;
  variable ntransactions;
  variable nlocations;
  variable col;


	 set nprocesses    [lindex $nl 0];
	 set ntransactions [lindex $nl 1];
	 set nlocations    [lindex $nl 2];
	 set col(0) bisque;
	 set col(1) SkyBlue;
	 set col(2) green;
	 set col(3) red;
	 set col(4) yellow;
	 set col(5) white;
	 set col(6) black;
	 set stepper 0;
	 set run     0;

	 $canv delete all

	 for {set i 0} {$i<$nprocesses} {incr i} {
	  $canv create rect \
		 10  [expr 60+80*$i]\
		 40  [expr 90+80*$i]\
		 -width 0 -fill $col($i) -tags process($i)
	  $canv create text 25 [expr 75+80*$i]\
				 -text P:$i -tags ptxt($i)  -font bold
	  $canv create rect \
		 950  [expr 40+90*$i]\
		 980 [expr 110+90*$i]\
		 -width 1 -fill $col($i) -tags localMemory($i)
  for {set j 0} {$j<$nlocations} {incr j} {
		 $canv create text 965 [expr 45+10*$j+90*$i]\
			  -anchor c  -tags lmtext($i)($j)
		}
	 }


	 $canv create rect \
		 40 20 \
		 1000 300 \
		 -outline $col(6) -width 3

	 $canv create text 960 30\
		 -anchor c -text LocalMemory

	 for {set i 0} {$i<$nlocations} {incr i} {
	 $canv create rect \
		 1020 [expr 100+15*$i]\
		 1050 [expr 115+15*$i]\
		 -width 1 -fill $col(4) -tags globalMemory($i)
	 $canv create text 1035 [expr 105+15*$i]\
			  -anchor c -text 0 -tags gmtext($i)
			 }

	 $canv create text 1050 80\
		 -anchor c -text GlobalMemory -tags gm


	 $canv create text 20 10\
		 -anchor c -text Time: -tags tmr -font bold

}


# timer --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc tmr {nl} {
  variable canv;
  variable nprocesses;
  variable ntransactions;
  variable nlocations;
  variable col;

  set ti [lindex $nl 0]

#$canv itemconfigure tmr -text Time:$ti

	 $canv create text [expr 60+50*$ti] 10\
				 -text $ti

}

# globalMemory --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc globalMemory {nl} {
  variable canv;
  variable nprocesses;
  variable ntransactions;
  variable nlocations;
  variable col;

  set loc  [lindex $nl 0]
  set val  [lindex $nl 1]

	 $canv itemconfigure gmtext($loc) -text $val



}

# localMemory --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc localMemory {nl} {
  variable canv;
  variable nprocesses;
  variable ntransactions;
  variable nlocations;
  variable col;

  set pro  [lindex $nl 0]
  set loc  [lindex $nl 1]
  set val  [lindex $nl 2]

	 $canv itemconfigure lmtext($pro)($loc) -text $val

}

# event --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc event {nl} {
  variable canv;
  variable nprocesses;
  variable ntransactions;
  variable nlocations;
  variable col;

  set pro  [lindex $nl 0]
  set tra  [lindex $nl 1]
  set eve  [lindex $nl 2]
  set evo  [lindex $nl 3]
  set evv  [lindex $nl 4]
  set tim  [lindex $nl 5]
  set beg  [lindex $nl 6]

  switch -exact -- $eve {
	0 { $canv create text [expr 100+50*$tim] [expr 75+80*$pro]\
				 -text Read($evo)

				 $canv create oval \
		 [expr 45+50*$beg] [expr 55+80*$pro]\
		 [expr 63+50*$beg] [expr 100+80*$pro]\
		 -width 0 -fill $col($pro)
	 $canv create text [expr 55+50*$beg] [expr 75+80*$pro]\
			  -anchor c -text T:$tra
			  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
	  }
	1 { $canv create text [expr 100+50*$tim] [expr 75+80*$pro]\
				 -text Write($evo,$evv)
				  $canv create oval \
		 [expr 45+50*$beg] [expr 55+80*$pro]\
		 [expr 63+50*$beg] [expr 100+80*$pro]\
		 -width 0 -fill $col($pro)
	 $canv create text [expr 55+50*$beg] [expr 75+80*$pro]\
			  -anchor c -text T:$tra

			  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
	  }
	2 { $canv create text [expr 100+50*$tim] [expr 75+80*$pro]\
				 -text TryCommit()
				  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
		}
	3 { $canv create text [expr 100+50*$tim] [expr 75+80*$pro]\
				 -text TryAbort()                    -font bold
				  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
	  }
	4 { $canv create text [expr 80+50*$tim] [expr 90+80*$pro]\
				 -text res-read-LocMem($evo,$evv)
				 for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
	  }
	5 { $canv create text [expr 80+50*$tim] [expr 90+80*$pro]\
				 -text res-read-GloMem($evo,$evv)
				  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
		  }
	6 { $canv create text [expr 80+50*$tim] [expr 90+80*$pro]\
				 -text res-write-OK()
				  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
					  }
	7 { $canv create text [expr 80+50*$tim] [expr 90+80*$pro]\
				 -text Commit()
				  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
	  }
	8 { $canv create text [expr 80+50*$tim] [expr 90+80*$pro]\
				 -text Abort()
				  for {set i 0} {$i<$nprocesses} {incr i} {
			  $canv create text [expr 70+50*$tim] [expr 100+80*$i]\
				 -text ...     }
	  }

  }
}




}; # end of namespace out
