/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2019 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * check ex0.v verilog prog
 *
 */

load "../library/conversion".
load "../library/exveri".
/* veri ex0.v 0 */
/* vdmp ex0.dmp */

set print_states = false.

define check_reg(X,Y) = {
   get(X) and 
   if avar(X)="R" then {
    if  strint(aval(X))=Y and atime(X)=2*strint(aval(X)) then {
     format("!%d:: Pass Reg test %d\n", atime(X), Y)
    } else {
     format("!%d:: Reg Prog %d, Real %d\n",atime(X), Y, strint(aval(X)))
      }
    } else {
       format("!%d:: Reg %d: Wrong input received %s\n",atime(X), Y, aval(X))
    }
}.

/* run */ define test() = {
    exists X,Y :{
      {Y=1 and veri_dot()};{skip and stable(Y)};
     while Y<=10 do {
      {check_reg(X,Y)};{skip and stable(Y)};
      {skip and Y:=Y+1};{skip and stable(Y)}
     }
  }
}.
    
    
